=== debian/changelog ===
libxpertmass (1.7.1-1build1) resolute; urgency=medium

  * No-change rebuild for boost 1.90.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 Feb 2026 12:30:08 +0100

libxpertmass (1.7.1-1) unstable; urgency=low

  * New release fixing glitches and adding new decimal places related
    code.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 12 Jan 2026 16:49:43 +0100

libxpertmass (1.7.0-1) unstable; urgency=low

  * New release implementing an action manager that manages QAction and
    shortcuts. ActionManager is successfully used in MineXpert.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 09 Jan 2026 17:20:20 +0100

libxpertmass (1.6.0-1) unstable; urgency=low

  * New release implementing 'Recent files...' concept for use in menus.

  * Minor improvements in the mass peak shaper code.

  * Depends on newer version of libpappsomspp.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 18 Dec 2025 19:02:08 +0100

libxpertmass (1.5.0-1) unstable; urgency=low

  * New release implementing fixed-mz-range bins for isotopic cluster
    calculations.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 05 Dec 2025 11:19:51 +0100

libxpertmass (1.4.2-1) unstable; urgency=low

  * New release due to upgrade of libpappsomspp version.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 29 Nov 2025 17:24:53 +0100

libxpertmass (1.4.1-1) unstable; urgency=low

  * New upstream release fixing one bug in the initialization of an Ionizer
    using another Ionizer.
  * Improvements to the GCOV-based code coverage.
  * All tests pass.
  * Update Build-Depends for libpappsomspp.
  * Update Build-Depends for libisospec++.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 03 Nov 2025 21:50:05 +0100
