## libxpertmass 1.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 project(
     XpertMass
-    VERSION 1.7.1
+    VERSION 1.8.1
     DESCRIPTION "Libraries [XpertMass::Core (non-GUI) and XpertMass::Gui) for the MsXpertSuite project."
     HOMEPAGE_URL "http://wwww.msxpertsuite.org/libxpertmass"
     LANGUAGES CXX
