=== source/XpertMassCore/CMakeLists.txt ===
--- 
+++ 
@@ -94,6 +94,9 @@
     # Scripting-related
     src/XpertMassCoreJavaScript.cpp
     src/jsclassregistrar.cpp
+    #
+    # Deconvolution of mass spectra
+    src/LowMassDeconvolver.cpp
 )
 
 qt6_add_resources(XpertMassCore_QRC_CPP xpertmasscore_resources.qrc)
