=== debian/changelog ===
libxpertmass (1.8.1-1) unstable; urgency=low

  * New release with new code implementing a low mass deconvolution algorithm.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 17 Feb 2026 15:24:07 +0100
